package cz.mendelu.dnaAnalyser.sequence

import cz.mendelu.dnaAnalyser.sequence.model.TestNucleicBuffer
import spock.lang.Ignore
import spock.lang.Specification

class SupplementNucleotideBufferTest extends Specification {

    def "opposite nucleic DNA"(){
        given:
        def a = new TestNucleicBuffer("AAATTTCCCGGG")
        def b = new SupplementNucleicBuffer(a)

        when:
        b.getRevertedNucleicBuffer()

        then:
        b.getNucleic(0).toByte()==(byte)'T'
        b.getNucleic(3).toByte()==(byte)'A'
        b.getNucleic(6).toByte()==(byte)'G'
        b.getNucleic(9).toByte()==(byte)'C'
    }


    def "opposite nucleic RNA"(){
        given:
        def a = new TestNucleicBuffer("AAAUUUCCCGGG")
        def b = new SupplementNucleicBuffer(a)

        when:
        b.getRevertedNucleicBuffer()

        then:
        b.getNucleic(0).toByte()==(byte)'U'
        b.getNucleic(3).toByte()==(byte)'A'
        b.getNucleic(6).toByte()==(byte)'G'
        b.getNucleic(9).toByte()==(byte)'C'
    }

}
